/*************************
**                      **
**  C++                 **
**  01/05/2024          **
**  Michel Aquino Lino  **
**  Arduino I            **
**  TRABAJO FINAL       **
**                      **
**************************/

#include <Servo.h>

#define SensorLDR A0
#define pinRojo   9
#define pinAzul   10
#define pinVerde  11

int valorRojo      = 0;
int valorSensorLDR = 0;

float tempC;

Servo myservo; 
int pos;

void setup()
{
  // Configuramos los pines como salidas
  pinMode(pinRojo,  OUTPUT);
  pinMode(pinAzul,  OUTPUT);
  pinMode(pinVerde, OUTPUT);
  
  // Conectamos el servo en el pin 6 al objeto servo
  myservo.attach(6); 
  
  // Inicialización del puerto serial a 9600 baudios para la comunicación con el monitor serial
  Serial.begin(9600);
}

void loop()
{ 
  // SENSOR LDR (fotoresistor: 6/679 ohm)
  valorSensorLDR = analogRead(SensorLDR);
  
  valorRojo = abs(((valorSensorLDR - 6)/2.63921) - 255);
  analogWrite(pinRojo,valorRojo);
  
  Serial.print("COLOR SIGNAL : Value = ");
  Serial.print(valorRojo);
  Serial.print(" --> Resistance = ");
  Serial.print(valorSensorLDR);
  Serial.println(" ohm");
  delay(1000); // Espera 1000 milisegundos (1 segundo) antes de realizar la siguiente lectura
  
  // SENSOR LM35 (temperatura: -40/125 °C)
  tempC = analogRead(A1);
  
  tempC = (5.0 * tempC * 100.0) / 1024.0 - 50;
  
  if(tempC < 18){
    pos = 0;
    myservo.write(pos);
    delay(15);
  }
  
  if(18 <= tempC && tempC <= 30){
    pos = (tempC - 18)*15;
    myservo.write(pos);
    delay(15);
  }
  
  if(30 < tempC){
    pos = 180;
    myservo.write(pos);
    delay(15);
  }
  
  Serial.print("TEMPERATURE SIGNAL: Value = ");
  Serial.print(tempC);
  Serial.print(char(176));
  Serial.print("C --> Angle = ");
  Serial.print(pos);
  Serial.print(char(176));
  Serial.print("\n");
  delay(1000); // Espera 1000 milisegundos (1 segundo) antes de realizar la siguiente lectura
}